""" Contains all the data models used in inputs/outputs """

from .absence import Absence
from .account import Account
from .agent import Agent
from .agent_lite import AgentLite
from .agent_permission import AgentPermission
from .agent_preview import AgentPreview
from .application_status import ApplicationStatus
from .career import Career
from .client_infos import ClientInfos
from .client_infos_headers import ClientInfosHeaders
from .complementary_activity import ComplementaryActivity
from .connector_status import ConnectorStatus
from .contract import Contract
from .count_modifications_types import CountModificationsTypes
from .count_modified_files_types import CountModifiedFilesTypes
from .discipline import Discipline
from .failed_end import FailedEnd
from .failed_reason import FailedReason
from .functional_assignment import FunctionalAssignment
from .get_absences_agent_details import GetAbsencesAgentDetails
from .get_agent_details import GetAgentDetails
from .get_connector_state_id import GetConnectorStateId
from .get_correspondence_type import GetCorrespondenceType
from .get_correspondences_type import GetCorrespondencesType
from .get_label_type import GetLabelType
from .get_labels_type import GetLabelsType
from .get_modifications_types import GetModificationsTypes
from .get_modified_files_types import GetModifiedFilesTypes
from .get_organizational_units_type import GetOrganizationalUnitsType
from .get_service_modes_details import GetServiceModesDetails
from .hierarchical_assignment import HierarchicalAssignment
from .hierarchical_assignment_preview import HierarchicalAssignmentPreview
from .input_mail import InputMail
from .job_type import JobType
from .label import Label
from .manager import Manager
from .modification import Modification
from .modification_details import ModificationDetails
from .ohris_agent import OhrisAgent
from .ohris_agent_assignments import OhrisAgentAssignments
from .organizational_unit import OrganizationalUnit
from .organizational_unit_lite import OrganizationalUnitLite
from .permission import Permission
from .personal_contact import PersonalContact
from .personal_details import PersonalDetails
from .personal_details_lite import PersonalDetailsLite
from .professional_contact import ProfessionalContact
from .receipt import Receipt
from .relative import Relative
from .security_credential import SecurityCredential
from .security_credential_extras import SecurityCredentialExtras
from .security_input_authenticate import SecurityInputAuthenticate
from .security_input_delete import SecurityInputDelete
from .security_input_set import SecurityInputSet
from .security_input_set_extras import SecurityInputSetExtras
from .security_outpu_secret import SecurityOutpuSecret
from .security_output_token import SecurityOutputToken
from .server_infos import ServerInfos
from .service_mode import ServiceMode
from .simple_label import SimpleLabel
from .situation_population import SituationPopulation
from .situation_status import SituationStatus
from .speciality import Speciality
from .support import Support

__all__ = (
    "Absence",
    "Account",
    "Agent",
    "AgentLite",
    "AgentPermission",
    "AgentPreview",
    "ApplicationStatus",
    "Career",
    "ClientInfos",
    "ClientInfosHeaders",
    "ComplementaryActivity",
    "ConnectorStatus",
    "Contract",
    "CountModificationsTypes",
    "CountModifiedFilesTypes",
    "Discipline",
    "FailedEnd",
    "FailedReason",
    "FunctionalAssignment",
    "GetAbsencesAgentDetails",
    "GetAgentDetails",
    "GetConnectorStateId",
    "GetCorrespondencesType",
    "GetCorrespondenceType",
    "GetLabelsType",
    "GetLabelType",
    "GetModificationsTypes",
    "GetModifiedFilesTypes",
    "GetOrganizationalUnitsType",
    "GetServiceModesDetails",
    "HierarchicalAssignment",
    "HierarchicalAssignmentPreview",
    "InputMail",
    "JobType",
    "Label",
    "Manager",
    "Modification",
    "ModificationDetails",
    "OhrisAgent",
    "OhrisAgentAssignments",
    "OrganizationalUnit",
    "OrganizationalUnitLite",
    "Permission",
    "PersonalContact",
    "PersonalDetails",
    "PersonalDetailsLite",
    "ProfessionalContact",
    "Receipt",
    "Relative",
    "SecurityCredential",
    "SecurityCredentialExtras",
    "SecurityInputAuthenticate",
    "SecurityInputDelete",
    "SecurityInputSet",
    "SecurityInputSetExtras",
    "SecurityOutpuSecret",
    "SecurityOutputToken",
    "ServerInfos",
    "ServiceMode",
    "SimpleLabel",
    "SituationPopulation",
    "SituationStatus",
    "Speciality",
    "Support",
)
