from typing import Any, Dict, List, Type, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="Discipline")


@_attrs_define
class Discipline:
    """Discipline de spécialité de niveau 1

    Attributes:
        speciality_code (Union[Unset, str]): Code de la spécialité de niveau 1
        discipline_code (Union[Unset, str]): Code de la discipline
        label (Union[Unset, str]): Libellé
        is_active (Union[Unset, bool]): Témoin d'activité
    """

    speciality_code: Union[Unset, str] = UNSET
    discipline_code: Union[Unset, str] = UNSET
    label: Union[Unset, str] = UNSET
    is_active: Union[Unset, bool] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        speciality_code = self.speciality_code
        discipline_code = self.discipline_code
        label = self.label
        is_active = self.is_active

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if speciality_code is not UNSET:
            field_dict["specialityCode"] = speciality_code
        if discipline_code is not UNSET:
            field_dict["disciplineCode"] = discipline_code
        if label is not UNSET:
            field_dict["label"] = label
        if is_active is not UNSET:
            field_dict["isActive"] = is_active

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        speciality_code = d.pop("specialityCode", UNSET)

        discipline_code = d.pop("disciplineCode", UNSET)

        label = d.pop("label", UNSET)

        is_active = d.pop("isActive", UNSET)

        discipline = cls(
            speciality_code=speciality_code,
            discipline_code=discipline_code,
            label=label,
            is_active=is_active,
        )

        discipline.additional_properties = d
        return discipline

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
