from typing import Any, Dict, List, Type, TypeVar, Union, cast

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="InputMail")


@_attrs_define
class InputMail:
    """
    Attributes:
        subject (Union[Unset, str]):
        message (Union[Unset, str]):
        from_ (Union[Unset, str]):
        cc (Union[Unset, List[str]]):
        bcc (Union[Unset, List[str]]):
    """

    subject: Union[Unset, str] = UNSET
    message: Union[Unset, str] = UNSET
    from_: Union[Unset, str] = UNSET
    cc: Union[Unset, List[str]] = UNSET
    bcc: Union[Unset, List[str]] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        subject = self.subject
        message = self.message
        from_ = self.from_
        cc: Union[Unset, List[str]] = UNSET
        if not isinstance(self.cc, Unset):
            cc = self.cc

        bcc: Union[Unset, List[str]] = UNSET
        if not isinstance(self.bcc, Unset):
            bcc = self.bcc

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if subject is not UNSET:
            field_dict["subject"] = subject
        if message is not UNSET:
            field_dict["message"] = message
        if from_ is not UNSET:
            field_dict["from"] = from_
        if cc is not UNSET:
            field_dict["cc"] = cc
        if bcc is not UNSET:
            field_dict["bcc"] = bcc

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        subject = d.pop("subject", UNSET)

        message = d.pop("message", UNSET)

        from_ = d.pop("from", UNSET)

        cc = cast(List[str], d.pop("cc", UNSET))

        bcc = cast(List[str], d.pop("bcc", UNSET))

        input_mail = cls(
            subject=subject,
            message=message,
            from_=from_,
            cc=cc,
            bcc=bcc,
        )

        input_mail.additional_properties = d
        return input_mail

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
