from typing import Any, Dict, List, Type, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="PersonalContact")


@_attrs_define
class PersonalContact:
    """Coordonnées de contact personnel

    Attributes:
        mail (Union[Unset, str]): Adresse mail
        mobile (Union[Unset, str]): Numéro de téléphone mobile
        home (Union[Unset, str]): Numéro de téléphone du domicile
    """

    mail: Union[Unset, str] = UNSET
    mobile: Union[Unset, str] = UNSET
    home: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        mail = self.mail
        mobile = self.mobile
        home = self.home

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if mail is not UNSET:
            field_dict["mail"] = mail
        if mobile is not UNSET:
            field_dict["mobile"] = mobile
        if home is not UNSET:
            field_dict["home"] = home

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        mail = d.pop("mail", UNSET)

        mobile = d.pop("mobile", UNSET)

        home = d.pop("home", UNSET)

        personal_contact = cls(
            mail=mail,
            mobile=mobile,
            home=home,
        )

        personal_contact.additional_properties = d
        return personal_contact

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
