from typing import Any, Dict, List, Type, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="ProfessionalContact")


@_attrs_define
class ProfessionalContact:
    """Coordonnées de contact professionnel

    Attributes:
        mail (Union[Unset, str]): Adresse mail
        mobile (Union[Unset, str]): Numéro de téléphone mobile
        office (Union[Unset, str]): Numéro de téléphone du bureau
        secondary (Union[Unset, str]): Numéro de téléphone secondaire
    """

    mail: Union[Unset, str] = UNSET
    mobile: Union[Unset, str] = UNSET
    office: Union[Unset, str] = UNSET
    secondary: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        mail = self.mail
        mobile = self.mobile
        office = self.office
        secondary = self.secondary

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if mail is not UNSET:
            field_dict["mail"] = mail
        if mobile is not UNSET:
            field_dict["mobile"] = mobile
        if office is not UNSET:
            field_dict["office"] = office
        if secondary is not UNSET:
            field_dict["secondary"] = secondary

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        if not src_dict:
            return None
        d = src_dict.copy()
        mail = d.pop("mail", UNSET)

        mobile = d.pop("mobile", UNSET)

        office = d.pop("office", UNSET)

        secondary = d.pop("secondary", UNSET)

        professional_contact = cls(
            mail=mail,
            mobile=mobile,
            office=office,
            secondary=secondary,
        )

        professional_contact.additional_properties = d
        return professional_contact

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
